package genList;

/**
 * Empty list of elements of type E
 * @param <E> the type of data elements that make up this list.
 */
public class EmptyList<E> extends List<E> { 

  /**
   * Constructor for this class.  This is NOT a singleton -- why?
   */
  public EmptyList() {}

    /**
   * Concrete method to accept the given visitor with the given input parameter(s) and return type.   Always calls the forEmpty() method of the visitor.
   * @param <R> the return type of the visitor
   * @param <P> the input parameter type of the visitor
   * @param visitor a visitor to this type of list that takes the given type of input parameters and returns the given type of return value.
   * @param params  Vararg of input parameters to hand to the visitor.
   * @return the result of running the visitor on this list.
   */
  public <R, P> R accept(IListVisitor<E, R, P> visitor, P... params) {
    return visitor.forEmpty(this, params);
  }

}

